changeset 388:23d40b345e1e

INV-197 create db backup helper scripts for inventory and workflow
author Matt Calmes <calmes@ssdt-ohio.org>
date Mon, 18 Oct 2021 06:33:33 -0400
parents 3dc92d4243ef
children 4e42c10e3c0d
files scripts/backup-container-docker.sh scripts/backup-inventory.sh scripts/exec-all-projects-docker.sh
diffstat 3 files changed, 134 insertions(+), 0 deletions(-) [+]
line wrap: on
line diff
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/scripts/backup-container-docker.sh	Mon Oct 18 06:33:33 2021 -0400
@@ -0,0 +1,77 @@
+#!/bin/bash
+# Executes a database backup for the specifed database container.  
+# The current directory is expected to contain a project configured
+# as with SSDT conventions for an application database.
+#
+# When successful, the output file will be in ./backup with the
+# container name and timestamp in the file.  The format of the output
+# is a compressed pg_dump (sql) format.
+#
+container=${1?Must provide container name to backup}
+
+projectDir=${2:-$PWD}
+
+project=${3?Must provide project name to backup}
+
+cd $projectDir
+
+source "${SSDT_SCRIPTS:-$(dirname "${BASH_SOURCE[0]}")}/.functions.sh"
+
+set -o pipefail
+mkdir -p ./backup
+
+if [ "$container" = "invdb" ]; then
+   function prop {
+       grep "${1}" .env/ssdt-inventory-shared.properties|cut -d'=' -f2
+   }
+   entityId=$(prop 'entityId' | tr -d '"')
+   containerName="$entityId-inventory-db"
+   IRN=$(docker exec $containerName psql --username=postgres --dbname=$container -t -c 'select districtirn from inventoryconfiguration')
+   backupFile=./backup/${IRN}${entityId}-${container}.$(date +%Y-%m-%d-%H-%M-%S).backup
+   echo "entityId is $entityId"
+   echo "container name is $containerName"
+fi
+
+#If the project is empty, we want to stop the process because this is being run from the wrong directory
+
+#if [ "$project" == "" ]; then
+#   echo "no project available"
+#   exit 1
+#fi
+#
+##Take out the extra space from IRN returned from db.
+IRN=`echo $IRN | sed -e 's/^[[:space:]]*//'`
+
+## if database is empty, it will put IRN 000000
+if [ "$IRN" == "" ]; then
+   echo "no IRN set,using 000000"
+    IRN=000000
+fi
+
+
+
+echo "Project is $project"
+echo "Container is $container"
+echo "IRN is $IRN"
+
+echo "backup file ${backupFile}"
+echo "preparing to backup ${container} on current project at ${projectDir}:"
+echo " "
+
+
+
+echo "starting backup of $container for $project"
+docker exec -t $containerName sh -c "gosu postgres pg_dump -Cc --if-exists --dbname=$container ; (exit $?) " > ${backupFile}
+#if [[ $( grep --count "CREATE TABLE" ${backupFile} ) -lt 200 || $( grep --count "PostgreSQL database dump complete" ${backupFile} ) -eq 0 ]]; then
+#   echo "ERROR: backup verification FAILED"
+#   echo "Error: empty database"
+#   echo "ERROR: $(tail ${backupFile})"
+  # We want the process to continue even if the db is blank
+  # exit 1
+#fi
+
+gzip ${backupFile}
+
+
+echo "completed backup of $container for $project to ${backupFile}"
+
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/scripts/backup-inventory.sh	Mon Oct 18 06:33:33 2021 -0400
@@ -0,0 +1,6 @@
+#!/bin/bash
+
+source "${SSDT_SCRIPTS:-$(dirname "${BASH_SOURCE[0]}")}/.functions.sh"
+
+${SSDT_SCRIPTS}/backup-container-docker.sh invdb ${1} inventory
+
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/scripts/exec-all-projects-docker.sh	Mon Oct 18 06:33:33 2021 -0400
@@ -0,0 +1,51 @@
+#!/bin/bash
+# Scans for docker projects in specified parent path and
+# executes the specified command.
+#
+# The first parameter specifices theparent directory to search for 
+# docker-compose.yml # files must be specified.  #
+# 
+# the second paramter specifies the command to execute against each
+# compose project.
+#
+# examples:
+#
+#   /ssdt/scripts/exec-all-projects.sh /data/prod docker-compose ps
+# 
+#     executes "docker-compose ps" against all projects under /data/prod
+#
+#   /ssdt/scripts/exec-all-projects.sh /data/prod /ssdt/ /ssdt/scripts/backup-usas.sh
+#
+#     runs backup-usas.sh script against all projects under /data/prod
+#
+#   /ssdt/scripts/exec-all-projects.sh /data/prod "/ssdt/scripts/capture.sh | /ssdt/scripts/send.sh -"
+#
+#       captures the log files from all containers and sends one log file per project 
+#       to the SSDT support server.
+#
+##
+
+source "${SSDT_SCRIPTS:-$(dirname "${BASH_SOURCE[0]}")}/.functions.sh"
+
+: ${1?"Usage: {parent path} [command]"}
+
+ORIGINALDIR=$PWD
+PARENTDIR=$1
+
+shift
+COMMAND=$@
+
+for f in $(find $PARENTDIR -type d -name .env)
+do
+   projectdir=`dirname $f`
+   project=`basename $projectdir`
+   cd $projectdir
+   echo "projectdir is $projectdir"
+   echo -e "----\n$executing $COMMAND on $project \n----"      
+
+   #bash -c "${COMMAND}"
+   echo ""
+
+done
+
+cd $ORIGINALDIR